#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <map>
#include <cstdlib> // for exit()
using namespace std;

#define done(r, m) { cout << r << '\n'; cerr << m << '\n'; exit(0); }

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	// we don't use the input file

	ifstream hint(argv[2]);
	map<char, int> res_hint;
	char c;
	int count;
	while (hint >> c >> count) {
		res_hint[c] = count;
	}

	ifstream output(argv[3]);
	if (!output) {
		done(0, "No output file");
	}
	map<char, int> res_out;
	string s;
	char dummy;
	while (getline(output, s)) {
		stringstream ss(s);
		ss >> c >> count;
		if (!ss || ss >> dummy) {
			done(0, "Invalid format");
		}
		if (res_out.count(c) > 0) {
			done(0, "Duplicate entry");
		}
		res_out[c] = count;
	}

	if (res_out != res_hint) {
		done(0, "Wrong answer");
	}
	done(1, "OK");
}
