// Simple generator - generates connected graph, then queries on that.
// use for stress testing
#include "testlib.h"
#include <iostream>
#include <set>

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  int n = opt<int>("n");
  int m = opt<int>("m"); // # of 1st type queries
  int q2 = opt<int>("q2"); // # of 2nd type queries

  set<pair<int, int>> edges;
  for (int i = 1; i < n; i++) {
    edges.insert(make_pair(rnd.next(i), i));
  }

  while ((int) edges.size() < m) {
    int u, v;
    do {
      u = rnd.next(n);
      v = rnd.next(n);
      if (u > v) swap(u, v);
    } while (u == v);
    edges.insert(make_pair(u, v));
  }

  cout << n << " " << m + q2 << '\n';
  for (auto e : edges) {
    cout << "+ " << 1 + e.first << " " << 1 + e.second << '\n';
  }

  for (int i = 0; i < q2; i++) {
    int k = rnd.next(m + 1);
    cout << "? " << k << '\n';
  }
}
