#ifndef QUERY_HPP
#define QUERY_HPP

#include <vector>

using std::pair;
using std::vector;

union QueryParameters {
  QueryParameters () {
  }
  
  pair<int, int> edge;
  int K;
};

struct Query {
  char type;
  QueryParameters params;
};

Query add_edge (pair<int, int> e) {
  Query q;
  q.type = '+';
  q.params.edge = e;
  return q;
}

Query ask (int K) {
  Query q;
  q.type = '?';
  q.params.K = K;
  return q;
}

void print_queries (int n, vector<Query> qs, std::ostream &out) {
  out << n << " " << qs.size() << std::endl;
  for (auto q : qs) {
    out << q.type << " ";
    if (q.type == '+') {
      out << 1 + q.params.edge.first << " " << 1 + q.params.edge.second;
    } else {
      out << q.params.K;
    }
    out << '\n';
  }
}

#endif
