#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
#include <vector>
#include <sstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
using namespace std;

#define a first
#define b second

typedef long long ll;
ll x,n;
double kokku;
vector<pair<ll,ll> > vp;    //Postide koordinaadid
pair<ll,ll> p0,p1;          //Punkt mille mber lejnud sorteeritakse
bool joonel=0;              //Kas aiad kattuvad

void lopeta(double score, string message){
	cerr<<message<<"\n";
	cout<<score<<"\n";
	exit(0);
}

ll algp(vector<ll> &nr,vector<pair<ll,ll> > &vp){           //Leiab alumise vasakpoolse punkti
	ll Y=vp[nr[0]].b,in=0;                                  //See on kindlasti kumerkattel
	for(ll i=1;i<nr.size();i++)
		if(Y>vp[nr[i]].b or (Y==vp[nr[i]].b and vp[nr[i]].a<vp[nr[in]].a))Y=vp[nr[i]].b,in=i;
	swap(nr[in],nr[0]);
	return nr[0];
}

ll vkor(pair<ll,ll> &a, pair<ll,ll> &b){   //Vektorkorrutis
	return (a.a-p0.a)*(b.b-p0.b)-(b.a-p0.a)*(a.b-p0.b);
}

ll vahe(pair<ll,ll> a, pair<ll,ll> b){     //Leiab kumb kahest punktist on keskkohast kaugemal
	return abs(a.a-p0.a)+abs(a.b-p0.b)-abs(b.a-p0.a)-abs(b.b-p0.b); //Et lhemad punktid enne tuleks
}

bool boo(ll &a,ll &b){                    //Sorteerib kik lejnud punktid mingi punkti jrgi
	if(vkor(vp[a],vp[b])>0) return 1;
	if(vkor(vp[a],vp[b])==0 and vahe(vp[a],vp[b])<0)return 1;
	return 0;
}

void loe(istream &in, vector<ll> &nr){     //Sisendfaili lugemine ja ettevalmistused kumerkatte leidmiseks
	in>>n>>kokku;
	ll a,b;
	vp.resize(0);
	for(ll i=0; i<n; i++){
		in>>a>>b;
		vp.push_back({a,b});
	}
	for(ll i=0; i<n; i++) nr.push_back(i);
	ll nr0=algp(nr,vp);
	p0=vp[nr0];
	sort(nr.begin()+1,nr.end(),boo);
}

vector<ll> kandidaadid(vector<pair<ll,ll> > &vp,vector<ll> &nr){     //Leiab kumerkatte punktide kandidaadid
	ll l=1,m=vp.size();                                      //Iga sirge pealt kaugeim ja esimeselt ja viimaselt kik
	vector<ll> kk={nr[0],nr[1]};        //l esimese sirge lpp;
	while(!vkor(vp[nr[l]],vp[nr[l+1]])){
		l++;
		kk.push_back(nr[l]);
	}

	ll r=m-1;               //r viimase sirge algus
	while(!vkor(vp[nr[r-1]],vp[nr[r]]))r--;
	l++;
	while(l<r){
		if(vkor(vp[nr[l]],vp[nr[l+1]])) kk.push_back(nr[l]);
		l++;
	}
	for(ll i=m-1;i>=r;i--)  kk.push_back(nr[i]);
	return kk;
}

vector<ll> kumerkate(vector<ll> &k){          //Leiab kumerkatte
	k.push_back(k[0]);
	ll m=k.size();
	vector<ll> ku={k[0],k[1]};
	for(ll i=2;i<m;i++){
		for(ll j=ku.size()-1;j>0;j--){
			p0=vp[ku[j-1]];
			if(vkor(vp[ku[j]],vp[k[i]])<0)ku.pop_back();
			else break;
		}
		if(i<m-1)ku.push_back(k[i]);
	}
	return ku;
}

vector<vector<ll> > teenaabrid(vector<ll> &ku){ //Leiab kumerkatte peal naabrid
	vector<vector<ll> > vv;
	vector<ll> v={};
	for(ll i=0; i<n; i++) vv.push_back(v);
	ll m=ku.size();
	for(ll i=0; i<m; i++) if(!i) vv[ku[i]].push_back(ku[m-1]),vv[ku[i]].push_back(ku[i+1]);
		else if(i==m-1)vv[ku[i]].push_back(ku[i-1]),vv[ku[i]].push_back(ku[0]);
		else vv[ku[i]].push_back(ku[i-1]),vv[ku[i]].push_back(ku[i+1]);
	return vv;
}

ll skor(pair<ll,ll> &a, pair<ll,ll> &b){     //skalaarkorrutis
	return (a.a-p0.a)*(b.a-p0.a)+(b.b-p0.b)*(a.b-p0.b);
}

bool A(pair<ll,ll> &a){
	ll c=vkor(a,p1);
	if(c>0)return 1;
	if(c==0){
		if(skor(a,p1)<0)return 1;
		joonel =1;
	}
	return 0;
}

bool boo1(ll &a,ll &b){
	pair<ll,ll> c=vp[a],d=vp[b];
	if(A(c)==A(d)){
		ll k=vkor(c,d);
		//cout<<c.a<<" "<<c.b<<" "<<d.a<<" "<<d.b<<"\n";
		if(k>0)return 1;
		if(k==0)joonel=1;
		return 0;
	}
	return !A(c) and A(d);
}


double kaug(pair<ll,ll> &a,pair<ll,ll> &b){ //Kahe punkti vaheline kaugus
	return sqrt((a.a-b.a)*(a.a-b.a)+(a.b-b.b)*(a.b-b.b));
}

vector<vector<ll> > teetraat(ll &tr, vector<pair<ll,ll> > &p,vector<vector<ll> > &kuna, double &pikk){        //Teeb teed, arvutab kogupikkuse, sorteerib
	vector<vector<ll> > vv; vv.resize(0);
	vector<ll> v={};
	for(ll i =0; i<n; i++) vv.push_back(v);
	ll x,y;
	for(ll i=0; i<tr; i++){
		x=p[i].a; y=p[i].b;
		x--; y--;
		pikk+=kaug(vp[x],vp[y]);
		vv[x].push_back(y),vv[y].push_back(x);
		if(kuna[x].size() and kuna[y].size()){
			if(kuna[x][1]==y)swap(vv[x][0],vv[x].back());
			else if(kuna[y][1]==x)swap(vv[y][0],vv[y].back());
		}
	}
	for(ll i=0; i<n; i++){
		p0=vp[i];
		p1=vp[vv[i][0]];
		sort(vv[i].begin()+1,vv[i].end(),boo1);
		if(joonel) break;
	}
	return vv;
}

vector<vector<pair<ll,ll> > > teemit(vector<vector<ll> > &tr){
	vector<vector<pair<ll,ll> > > mit;
	vector<pair<ll,ll> > pr={};
	for(ll i=0; i<n; i++) mit.push_back(pr);
	for(ll i=0; i<n; i++) for(ll j=0; j<tr[i].size(); j++) mit[tr[i][j]].push_back({i,j});
	for(ll i=0; i<n; i++) sort(mit[i].begin(),mit[i].end());
	return mit;
}

vector<vector<pair<ll,ll> > > teesiin(vector<vector<ll> > &tr){
	vector<vector<pair<ll,ll> > > siin;
	vector<pair<ll,ll> > pr={};
	for(ll i=0; i<n; i++) siin.push_back(pr);
	for(ll i=0; i<n; i++) for(ll j=0; j<tr[i].size(); j++) siin[i].push_back({tr[i][j],j});
	for(ll i=0; i<n; i++) sort(siin[i].begin(),siin[i].end());
	return siin;
}

bool kontr(vector<vector<pair<ll,ll> > > mit,
		vector<vector<pair<ll,ll> > > siin, vector<vector<ll>> kuna,
		vector<vector<ll>> tr){                                      //Kontrolli likumist
	bool b=1;
	for(ll i=0; i<n; i++){
		ll mm=mit[i].size();
		for(ll j=0; j<mm; j++) if(mit[i][j].a>i){
			ll c=mit[i][j].a,cy=mit[i][j].b;
			ll s=kuna[i].size();
			ll mmm=tr[c].size();

			if(!s or c!=kuna[i][1]){ //parempoolne olemas
				ll psi=tr[i][(siin[i][j].b-1+mm)%mm];
				ll vse=tr[c][(cy+1)%mmm];
				if(psi!=vse)b=0;
			} else  if(!s or c!=kuna[i][0]){ //vasakpoolne olemas
				ll vsi=tr[i][(siin[i][j].b+1)%mm];
				ll pse=tr[c][(cy-1+mmm)%mmm];
				if(vsi!=pse)b=0;
			}
			if(b==0)        return 0;
		}
	}
	return b;
}

//See loeb ka lahendaja vljundit, peab olema kuulikindel
double tulemus(istream &in,vector<vector<ll> > &kuna){
	string s; char c;
	if(!getline(in, s)) lopeta(0,"Premature end of file");
	istringstream iss(s);
	ll k,l,r;
	double d;
	if(!(iss>>k>>d) or iss>>c) lopeta(0,"Invalid file format");
	if(k!=x) lopeta(0,"Wrong number of edges");
	if(d>kokku) lopeta(0,"Too much wire used");
	vector<pair<ll,ll> > p;
	for(ll line_index=0; getline(in, s); ){
		istringstream iss(s);
		if(!(iss>>l>>r) or iss>>c) lopeta(0,"Invalid file format");
		if(1>l or l>n or 1>r or r>n or l==r) lopeta(0,"Invalid network");
		p.push_back({l,r});
	}
	if(p.size()!=k) lopeta(0,"Premature end of file");
	if(in>>c) lopeta(0,"Invalid file format");
	double pikk=0;
	vector<vector<ll> > vv;
	vv= teetraat(k,p,kuna,pikk);
	if(abs(pikk-d)>=0.000001) lopeta(0,"Invalid length");
	if(joonel) lopeta(0,"Invalid network");
	vector<vector<pair<ll,ll> > > mit, siin;
	mit = teemit(vv);
	siin = teesiin(vv);
	bool kont=kontr(mit, siin, kuna, vv);
	if(!kont) lopeta(0,"Invalid network");
	return d;
}


int main(int argc, char** args){
	if(argc != 4) {
		cerr << "Invalid no. of arguments. Usage:\n" << args[0] << " [input file] [correct solution] [solution to test]\n";
		cout<<0<<"\n";
		return 0;
	}
	ifstream in(args[1]), cor(args[2]), out(args[3]);
	vector<ll> nr;
	loe(in, nr);
	vector<ll> kk=kandidaadid(vp,nr);
	vector<ll> kuka=kumerkate(kk);
	vector<vector<ll> > kunaabrid=teenaabrid(kuka);
	double parim; cor>>x>>parim; //Nidislahendusest loeme ainult esimese rea
	double hetke=tulemus(out,kunaabrid);
	double tul=(kokku-hetke)/(kokku-parim);
	stringstream ss; ss<<fixed<<setprecision(6)<<hetke;
	//cout<<kokku<<" "<<hetke<<" "<<parim<<"\n";
	lopeta(min(tul,1.0),"OK, L="+ss.str());
}
