#include <iostream>
#include <ios>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>

struct punkt {
	long long x, y; // koordinaadid
};

std::vector<punkt> punktid; // postide asukohad sisendist

struct loik {
	int a, b; // otspunktide indeksid punktide massiivis
};

struct vektor {
	long long x, y; // koordinaadid
	vektor(const punkt & a, const punkt & b) : x(b.x - a.x), y(b.y - a.y) {}
	vektor(const loik & s) : vektor(punktid[s.a], punktid[s.b]) {}
};

// skalaarkorrutis
long long skorr(const vektor & v1, const vektor & v2) {
	return v1.x * v2.x + v1.y * v2.y;
}

// vektorkorrutise märk
int vkorr(const vektor & v1, const vektor & v2) {
	long long vk = v1.x * v2.y - v2.x * v1.y;
	if (vk < 0) return -1;
	if (vk > 0) return +1;
	return 0;
}

// kas kaks lõiku lõikuvad?
// lõikumiseks loeme ka seda, kui ühe otspunkt on teise sisepunkt
// seega ka seda, kui lõigud osaliselt või täielikult kattuvad
bool loikuvad(const loik & s, const loik & t) {
	vektor vs(punktid[s.a], punktid[s.b]);
	vektor vsa(punktid[s.a], punktid[t.a]);
	vektor vsb(punktid[s.a], punktid[t.b]);
	int vksa = vkorr(vs, vsa), vksb = vkorr(vs, vsb);
	long long sks = skorr(vs, vs);
	long long sksa = skorr(vs, vsa);
	long long sksb = skorr(vs, vsb);

	vektor vt(punktid[t.a], punktid[t.b]);
	vektor vta(punktid[t.a], punktid[s.a]);
	vektor vtb(punktid[t.a], punktid[s.b]);
	int vkta = vkorr(vt, vta), vktb = vkorr(vt, vtb);
	long long skt = skorr(vt, vt);
	long long skta = skorr(vt, vta);
	long long sktb = skorr(vt, vtb);

	if (vksa * vksb < 0 && vkta * vktb < 0) {
		return true;
	}
	if (vksa == 0 && sksa > 0 && sksa < sks) {
		return true;
	}
	if (vksb == 0 && sksb > 0 && sksb < sks) {
		return true;
	}
	if (vkta == 0 && skta > 0 && skta < skt) {
		return true;
	}
	if (vktb == 0 && sktb > 0 && sktb < skt) {
		return true;
	}
	return false;
}

int main() {
	int n;
	double m;
	std::cin >> n >> m;
	punktid.resize(n);
	for (punkt & p : punktid) {
		std::cin >> p.x >> p.y;
	}
	std::vector<loik> loigud;
	for (int a = 0; a < n; ++a) {
		for (int b = a + 1; b < n; ++b) {
			loigud.push_back(loik{a, b});
		}
	}
	std::sort(loigud.begin(), loigud.end(),
		[](const loik & s, const loik & t) {
			return skorr(s, s) < skorr(t, t);
		}
	);
	std::vector<loik> traadid;
	for (const loik & s : loigud) {
		bool loikab = false;
		for (const loik & t : traadid) {
			if (loikuvad(s, t)) {
				loikab = true;
				break;
			}
		}
		if (!loikab) {
			traadid.push_back(s);
		}
	}
	double pikkus = 0;
	for (const loik & t : traadid) {
		pikkus += std::sqrt(skorr(t, t));
	}
	std::cout << traadid.size() << " " <<
		std::fixed << std::setprecision(6) << pikkus << "\n";
	for (const loik & t : traadid) {
		std::cout << t.a + 1 << " " << t.b + 1 << "\n";
	}
}
