#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <cstdlib> // for exit()
using namespace std;

#define done(r, m) { cout << r << '\n'; cerr << m << '\n'; exit(0); }

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	ifstream input(argv[1]);
	int m, n, k;
	input >> m >> n >> k;
	vector<int> p(m), w(m);
	for (int i = 0; i < m; ++i) {
		input >> p[i] >> w[i];
	}

	int l1, t1, l2, t2, b;
	long long laps;

	ifstream hint(argv[2]);
	long long time_hint = 0;
	hint >> t1 >> b;
	l1 = 0;
	for (int i = 0; i < b; ++i) {
		hint >> l2 >> t2;
		laps = l2 - l1;
		time_hint += p[t1 - 1] * laps + w[t1 - 1] * laps * (laps - 1) / 2 + k;
		l1 = l2; t1 = t2;
	}
	laps = n - l1;
	time_hint += p[t1 - 1] * laps + w[t1 - 1] * laps * (laps - 1) / 2;

	ifstream output(argv[3]);
	if (!output) {
		done(0, "No output file");
	}
	long long time_out = 0;
	string s;
	char dummy;
	if (!getline(output, s)) {
		done(0, "Invalid format");
	}
	stringstream ss(s);
	ss >> t1 >> b;
	if (!ss || ss >> dummy) {
		done(0, "Invalid format");
	}
	if (t1 < 1 || t1 > m || b < 0) {
		done(0, "Invalid answer");
	}
	l1 = 0;
	for (int i = 0; i < b; ++i) {
		if (!getline(output, s)) {
			done(0, "Invalid format");
		}
		stringstream ss(s);
		ss >> l2 >> t2;
		if (l2 <= l1 || l2 >= n || t2 < 1 || t2 > m) {
			done(0, "Invalid answer");
		}
		laps = l2 - l1;
		time_out += p[t1 - 1] * laps + w[t1 - 1] * laps * (laps - 1) / 2 + k;
		l1 = l2; t1 = t2;
	}
	laps = n - l1;
	time_out += p[t1 - 1] * laps + w[t1 - 1] * laps * (laps - 1) / 2;
	if (output >> dummy) {
		done(0, "Invalid format");
	}

	if (time_out > time_hint) {
		done(0, "Suboptimal strategy");
	}
	if (time_out < time_hint) {
		done(1, "OK+");
	}
	done(1, "OK");
}
