import fileinput
from typing import List, Tuple
from functools import lru_cache
#import numpy as np
#from numpy.core.defchararray import index


lines = [line for line in fileinput.input()]
m, n, k = [int(x) for x in lines[0].split()]
tires = [[int(s) for s in line.split()] for line in lines[1:]]

inf = float("inf")


def tire_time(p: int, w: int, n: int):
    return n * (2 * p + (n - 1) * w) / 2


def solve(n: int, m: int, k: int, tires: List[List[int]]):
    dp = [[None] * n for _ in range(m)]
    choices = [[None] * n for _ in range(m)]

    for i in range(m):
        for j in range(n):
            previous_tires_result = inf if i == 0 else dp[i - 1][j]

            laps = [
                    dp[i][lap] + k + tire_time(tires[i][0], tires[i][1], j - lap)
                    for lap in range(j)
            ]

            replace_current_tire_some_laps_ago = min(laps, default=inf)
            drive_from_start_cost = tire_time(tires[i][0], tires[i][1], j + 1)
            options = [
                replace_current_tire_some_laps_ago,
                drive_from_start_cost,
                previous_tires_result,
            ]
            dp[i][j] = min(options)
            choices[i][j] = options.index(dp[i][j])
            if choices[i][j] == 0:
                choices[i][j] = (
                    0,
                    laps.index(dp[i][j]),
                )  # make a tuple with the second element being the number of laps

    #print(np.array(dp))
    #print(np.array(choices))

    tire_changes = []

    initial_tire = None

    i = m - 1
    j = n - 1
    while i >= 0 or j >= 0:
        if choices[i][j] == 1:
            initial_tire = i
            break
        elif choices[i][j] == 2:
            i -= 1
        else:
            j = choices[i][j][1]
            tire_changes.append([j, i])

    return dp[m - 1][n - 1], tire_changes[::-1], initial_tire


num_laps, tire_changes, initial_tire = solve(n, m, k, tires)
print(initial_tire + 1, len(tire_changes))
for lap, tire in tire_changes:
    print(lap + 1, tire + 1)
