import fileinput
from functools import lru_cache
import sys
sys.setrecursionlimit(1500)

lines = [line for line in fileinput.input()]

m, n, k = [int(x) for x in lines[0].split()]

rehvid = [[int(s) for s in line.split()] for line in lines[1:]]

def rehvinumber(rehv):
    return rehvid.index(rehv) + 1


# iga ring kontrollime, kas peaksime pärast seda boksipeatuse tegema
@lru_cache(None)
def solve(n, w, praegune):
    if n == 0:
        return 0, (None,)
    parim, parimad_rehvid = solve(n - 1, w, praegune + w)
    uus_rehv = None
    for rehv in rehvid:
        kandidaat, kandidaatrehvid = solve(n-1, rehv[1], rehv[0])
        kandidaat += k # pit stop time
        if kandidaat < parim:
            parim = min(kandidaat, parim)
            parimad_rehvid = kandidaatrehvid
            uus_rehv = rehv


    return praegune + parim, (uus_rehv,) + parimad_rehvid
        
parim = float('inf')
parimad_rehvid = None
algusrehv = None
for rehv in rehvid:
    kandidaat,kandidaatrehvid = solve(n, rehv[1], rehv[0])
    if kandidaat < parim:
        parim = kandidaat
        parimad_rehvid = kandidaatrehvid
        algusrehv = rehv

rehvivahetused = [(i + 1, rehvinumber(parimad_rehvid[i])) for i in range(len(parimad_rehvid)) if parimad_rehvid[i] is not None]

print(rehvinumber(algusrehv), len(rehvivahetused))
for rehvivahetus in rehvivahetused:
    print(*rehvivahetus)



