import fileinput
from functools import lru_cache
import sys
sys.setrecursionlimit(1500)

lines = [line for line in fileinput.input()]

m, n, k = [int(x) for x in lines[0].split()]

rehvid = [[int(s) for s in line.split()] for line in lines[1:]]


# iga ring kontrollime, kas peaksime pärast seda boksipeatuse tegema
@lru_cache(None)
def solve(n, w, praegune, praegune_indeks):
    if n == 0:
        return 0, (None,)
    parim, parimad_rehvid = solve(n - 1, w, praegune + w, praegune_indeks)
    uus_rehv = None
    rehviindeks = praegune_indeks
    for rehv in rehvid[praegune_indeks:]:
        kandidaat, kandidaatrehvid = solve(n-1, rehv[1], rehv[0], rehviindeks)
        rehviindeks += 1
        kandidaat += k # pit stop time
        if kandidaat < parim:
            parim = min(kandidaat, parim)
            parimad_rehvid = kandidaatrehvid
            uus_rehv = rehviindeks

    return praegune + parim, (uus_rehv,) + parimad_rehvid
        
parim = float('inf')
parimad_rehvid = None
algusrehv = None
for i, rehv in enumerate(rehvid):
    kandidaat,kandidaatrehvid = solve(n, rehv[1], rehv[0], i)
    if kandidaat < parim:
        parim = kandidaat
        parimad_rehvid = kandidaatrehvid
        algusrehv = i

rehvivahetused = [(i + 1, parimad_rehvid[i]) for i in range(len(parimad_rehvid)) if parimad_rehvid[i] is not None]

print(algusrehv + 1, len(rehvivahetused))
for rehvivahetus in rehvivahetused:
    print(*rehvivahetus)



