import fileinput
from typing import List, Tuple
from functools import lru_cache
import numpy as np
from numpy.core.defchararray import index
from z3 import *


lines = [line for line in fileinput.input()]
m, n, k = [int(x) for x in lines[0].split()]
tires = [[int(s) for s in line.split()] for line in lines[1:]]


o = Optimize()
#usage = EmptySet(Int)

total_time = 0
current_tire_speed = 0
current_tire_w = 0

for i in range(n):
    li = Int(f'l{i}')
    o.add(li >= -1)
    if i == 0:
        o.add(li >= 0)
    o.add(li < m)
    for j in range(len(tires)):
        current_tire_speed = If(li == j, tires[j][0], current_tire_speed)
        current_tire_w = If(li == j, tires[j][1], current_tire_w)
        if i == 0:
            total_time = If(li == j, tires[j][0], total_time)
        else:
            total_time = If(li == j, total_time + k + tires[j][0], total_time)
    total_time = If(li == -1, total_time + current_tire_speed + current_tire_w, total_time)
    current_tire_speed = If(li == -1, current_tire_speed + current_tire_w, total_time)

print("Starting solving")
o.minimize(total_time)
print(o.check())
print(o.model())
print(o.model().eval(total_time))